Attribute VB_Name = "modMouseHook"
Option Explicit

Public Enum MouseType
    Left = 0
    Right = 1
    Others = 2
End Enum

Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Type MOUSEHOOKSTRUCT
    pt              As POINTAPI
    hwnd            As Long
    wHitTestCode    As Long
    dwExtraInfo     As Long
End Type

Public Declare Function GetSystemMetrics Lib "user32.dll" ( _
               ByVal nIndex As Long) As Long
Public Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" ( _
               ByVal idHook As Long, _
               ByVal lpfn As Long, _
               ByVal hmod As Long, _
               ByVal dwThreadId As Long) As Long
Public Declare Function UnhookWindowsHookEx Lib "user32" ( _
               ByVal hHook As Long) As Long
Public Declare Function CallNextHookEx Lib "user32" ( _
               ByVal hHook As Long, _
               ByVal nCode As Long, _
               ByVal wParam As Long, _
               ByVal lParam As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
               pDest As Any, _
               pSource As Any, _
               ByVal cb As Long)
Public Declare Function GetDoubleClickTime Lib "user32.dll" () As Long
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long

Public Const SM_CXDOUBLECLK     As Long = 36
Public Const SM_CYDOUBLECLK     As Long = 37
Public Const WM_LBUTTONDOWN     As Long = &H201 '513
Public Const WM_LBUTTONUP       As Long = &H202 '514
Public Const WM_RBUTTONDOWN     As Long = &H204 '516
Public Const WM_RBUTTONUP       As Long = &H205 '517
Public Const WM_MOUSEMOVE       As Long = &H200
Private Const WH_MOUSE_LL       As Long = 14
Private Const HC_ACTION         As Long = 0&
Public m_Hook                   As Long
Public lngDoubleClickTime       As Long
Public lngDoubleClickX          As Long
Public lngDoubleClickY          As Long
Public bolLeftClicked           As Boolean
Private bolFirstCriteriaMet     As Boolean
Private bolSecondCriteriaMet    As Boolean
Private bolThirdCriteriaMet     As Boolean
Private bolFinishLeftClick      As Boolean
Private bolFinishRightClick     As Boolean
Public CTest                    As clsDoubleClick

Public Sub Hook()
    m_Hook = SetWindowsHookEx(WH_MOUSE_LL, AddressOf LowLevelMouseProc, App.hInstance, 0&)
End Sub

Public Sub UnHook()
    UnhookWindowsHookEx m_Hook
End Sub

Public Function LowLevelMouseProc(ByVal nCode As Long, _
                                  ByVal wParam As Long, _
                                  ByVal lParam As Long) As Long

    Dim MouseData As MOUSEHOOKSTRUCT
    
    ' Display the screen resolution -- i.e., the width and height of the screen.
    If nCode = HC_ACTION Then
    
        If bolFirstCriteriaMet = False Then
            
            Select Case wParam
            Case WM_LBUTTONDOWN
                Debug.Print "first WM_LBUTTONDOWN"
            
                If GetClickInterval() = True Then
                    CopyMemory MouseData, ByVal lParam, Len(MouseData)
                    If CTest.IsDoubleClick(Left, MouseData.pt.x, MouseData.pt.y, GetTickCount) = True Then
                        bolFinishLeftClick = True
                    End If
                End If
            Case WM_LBUTTONUP
                Debug.Print "first WM_LBUTTONUP", bolFinishLeftClick
                If bolFinishLeftClick = True Then
                    bolFirstCriteriaMet = True
                    bolFinishLeftClick = False
                End If
            Case WM_MOUSEMOVE 'ignore mouse move
                
            Case Else 'reset for other mouse input
                Debug.Print "first ELSE"
                ResetCriteria wParam
            End Select
            
        ElseIf bolSecondCriteriaMet = False Then
            
            Select Case wParam
            Case WM_RBUTTONDOWN
                Debug.Print "second WM_RBUTTONDOWN"
                If GetClickInterval() = True Then
                    bolFinishRightClick = True
                End If
            Case WM_RBUTTONUP
                If bolFinishRightClick = True Then
                    Debug.Print "bolFinishRightClick"
                    bolSecondCriteriaMet = True
                    Set CTest = New clsDoubleClick
                    bolFinishRightClick = False
                End If
            Case WM_MOUSEMOVE 'ignore mouse move
                
            Case Else 'reset for other mouse input
                Debug.Print "second ELSE"
                ResetCriteria wParam
            End Select
            
        ElseIf bolThirdCriteriaMet = False Then
            
            Select Case wParam
            Case WM_LBUTTONDOWN
                Debug.Print "third WM_LBUTTONDOWN"
            
                If GetClickInterval() = True Then
                    CopyMemory MouseData, ByVal lParam, Len(MouseData)
                    If CTest.IsDoubleClick(Left, MouseData.pt.x, MouseData.pt.y, GetTickCount) = True Then
                        bolFinishLeftClick = True
                    End If
                End If
            Case WM_LBUTTONUP 'ignore mouse up since it comes from here
                If bolFinishLeftClick = True Then
                    Debug.Print "Hotkey Successful", Time
                    Form1.Print "Hotkey Successful"
                    Beep
                    ResetCriteria wParam
                End If
            Case WM_MOUSEMOVE 'ignore mouse move
                
            Case Else 'reset for other mouse input
                Debug.Print "third Else"
                ResetCriteria wParam
            End Select
        End If
    End If
    LowLevelMouseProc = CallNextHookEx(m_Hook, nCode, wParam, lParam)
End Function

Private Sub ResetCriteria(ByVal lParam As Long)
    Debug.Print lParam
    Set CTest = New clsDoubleClick
    bolFirstCriteriaMet = False
    bolSecondCriteriaMet = False
    bolThirdCriteriaMet = False
    bolLeftClicked = False
    bolFinishLeftClick = False
    bolFinishRightClick = False
    GetClickInterval
End Sub

Private Function GetClickInterval() As Boolean
    Static TimeLastPress    As Double
    Dim sCurrentTick        As Double

    sCurrentTick = GetTickCount
    GetClickInterval = (sCurrentTick - TimeLastPress) <= 2000 'lngDoubleClickTime
    If TimeLastPress = 0 Then GetClickInterval = True
    TimeLastPress = GetTickCount
End Function
